BREAK ON
CLS
@ECHO OFF
IF NOT %2%%Z == %%Z IF EXIST %1.inc GOTO START
IF NOT %2%%Z == %%Z IF EXIST %1.TXT GOTO START

ECHO.                   LINE EXCLUDE BATCH PROGRAM
ECHO.             EXCLUDE COPYRIGHT (C) 1995 CHUCK BERNT 
ECHO.                      ALL RIGHTS RESERVED
echo.
echo.  This batch program removes lines from a file based on characters 
echo.  found in those lines.  The program then places those lines in
echo.  an exclude file.  The program also stores a record of all excluding
echo.  phrases for later replay.  The search is not case sensitive.  This 
echo.  program is exclusively a batch program and for that reason
echo.  it is not as flexible as most of the other text programs.
echo. 
echo.  TO USE: Call this program again and give the filename without the 
echo.          extension and with the excluding characters.  The syntax is
echo.           as follows.
ECHO.
ECHO.                      EXCLUDE FILENAME "CHARACTERS"
echo.
echo.  NOTES: 
echo.        A. The filename above is given without an extension.
echo.        B. No commas are allowed in "CHARACTERS".  Up to five
echo.           spaces are allowed as long as none are adjacent.
echo.        C. The program uses FILENAME.TMP as a temporary file
echo.           and then removes it.
pause
cls
echo.
echo.  The program checks to see if filename.INC exists - if not 
echo.  it requests your permission to copy filename.TXT to 
echo.  filename.INC and then continues.
echo.
echo.  Before any exclusions are made the program will list all candidate
echo.  lines for removal. If the listing shows only valid removals
echo.  then with your approval the program removes those listings from the
echo.  filename.INC file and places them at the end of filename.EXC file.
echo.  The program also places the excluding phrase at the end of the file 
echo.  filename.WDL.  Filename.WDL serves as a word list of all excluding
echo.  phrases and can be replayed to recreate the filename.INC
echo.  file or to remove lines from other files using the same
echo.  excluding characters.
echo.
echo.  If you look at filename.WDL, you will see a list of every command
echo.  that was given to generate the filename.INC file with the word
echo.  'CALL' preceding each command.  The word 'CALL' will allow the
echo.  list to be executed as a batch program if the file extension is
echo.  changed from .WDL to .BAT.  The program will still ask you
echo.  to confirm each change by typing a carriage return before 
echo.  the change is made.
ECHO.
PAUSE
CLS
ECHO.
echo.  To replay the filename.WDL file: 
echo.       1. Rename it to any unused name.BAT file.  Make sure
echo.          that filename.WDL is removed not just copied.  The
echo.          program will append to it as it did the first time.
echo.       2. Delete filename.INC and filename.EXC.
echo.       3. Type name.
echo.
echo.  To process another filename with the word list:
echo.       1. Just copy filename1.WDL to any unused name.BAT file.
echo.       2. Change the filename in the name.BAT to the new filename.
echo.       3. Move the new filename's .INC and .EXC files if present.
echo.       4. Type name (the name.BAT file must be in the directory that
echo.          contains the new file or in one of your path directories).
echo.
echo.   These instructions will be suppressed when the complete
echo.   EXCLUDE syntax is used.
ECHO.
GOTO END

:START
IF EXIST %1.TXT IF NOT EXIST %1.INC GOTO FILECP
:START1
ECHO.
ECHO.             EXCLUDE COPYRIGHT (C) 1995 CHUCK BERNT 
ECHO.                      ALL RIGHTS RESERVED
ECHO.
ECHO.
ECHO            TO ABORT TYPE CONROL+C OR CONROL+BREAK
ECHO.
find /i %2 %3 %4 %5 %6 %7 %8 %1.INC | more
ECHO.
ECHO TYPE CONTROL C TO PREVENT REMOVAL OF THE ABOVE LISTINGS OR
pause
CLS
ECHO.
ECHO.
ECHO            TO ABORT TYPE CONROL+C OR CONROL+BREAK
ECHO.
Echo          Although you will be given a chance to continue,
echo          it is better to start over because some of 
echo          what is typed at the keyboard will be placed 
echo          in the output files.
ECHO.
ECHO.
ECHO.  >> %1.EXC
ECHO                   EXCLUDING PHRASE = %2 %3 %4 %5 %6 %7 %8 >> %1.EXC
find /i %2 %3 %4 %5 %6 %7 %8 %1.INC >> %1.EXC
find /i /v %2 %3 %4 %5 %6 %7 %8 %1.INC > %1.TMP
del %1.INC
ren %1.TMP %1.INC
ECHO CALL EXCLUDE %1 %2 %3 %4 %5 %6 %7 %8 >> %1.WDL
CLS
ECHO.
ECHO.
ECHO.
ECHO.
ECHO. *** THE EXCLUSION HAS COMPLETED NORMALLY AND ALL FILES ARE CLOSED ***
ECHO.
ECHO.         YOU MAY WANT TO EDIT OUT THE HEADING IN THE %1.INC FILE
ECHO.
GOTO END

:FILECP
ECHO. FILE %1.INC DOES NOT EXIST.   PLEASE AUTHORIZE COPYING OF %1.TXT
ECHO. TO %1.INC BY TYPING ANY KEY OR TYPE CONTROL C TO ABORT.
ECHO.
PAUSE
COPY %1.TXT %1.INC
ATTRIB -R %1.INC
GOTO START1


:END


